/*
 * Blockdaemon REST API
 *
 * Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// TxCreateContract The contract object.
type TxCreateContract struct {
	// The address of the contract.
	Address *string `json:"address,omitempty"`
	// The type of contract.
	Type *string `json:"type,omitempty"`
}

// NewTxCreateContract instantiates a new TxCreateContract object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTxCreateContract() *TxCreateContract {
	this := TxCreateContract{}
	return &this
}

// NewTxCreateContractWithDefaults instantiates a new TxCreateContract object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTxCreateContractWithDefaults() *TxCreateContract {
	this := TxCreateContract{}
	return &this
}

// GetAddress returns the Address field value if set, zero value otherwise.
func (o *TxCreateContract) GetAddress() string {
	if o == nil || o.Address == nil {
		var ret string
		return ret
	}
	return *o.Address
}

// GetAddressOk returns a tuple with the Address field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxCreateContract) GetAddressOk() (*string, bool) {
	if o == nil || o.Address == nil {
		return nil, false
	}
	return o.Address, true
}

// HasAddress returns a boolean if a field has been set.
func (o *TxCreateContract) HasAddress() bool {
	if o != nil && o.Address != nil {
		return true
	}

	return false
}

// SetAddress gets a reference to the given string and assigns it to the Address field.
func (o *TxCreateContract) SetAddress(v string) {
	o.Address = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *TxCreateContract) GetType() string {
	if o == nil || o.Type == nil {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxCreateContract) GetTypeOk() (*string, bool) {
	if o == nil || o.Type == nil {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *TxCreateContract) HasType() bool {
	if o != nil && o.Type != nil {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *TxCreateContract) SetType(v string) {
	o.Type = &v
}

func (o TxCreateContract) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Address != nil {
		toSerialize["address"] = o.Address
	}
	if o.Type != nil {
		toSerialize["type"] = o.Type
	}
	return json.Marshal(toSerialize)
}

type NullableTxCreateContract struct {
	value *TxCreateContract
	isSet bool
}

func (v NullableTxCreateContract) Get() *TxCreateContract {
	return v.value
}

func (v *NullableTxCreateContract) Set(val *TxCreateContract) {
	v.value = val
	v.isSet = true
}

func (v NullableTxCreateContract) IsSet() bool {
	return v.isSet
}

func (v *NullableTxCreateContract) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTxCreateContract(val *TxCreateContract) *NullableTxCreateContract {
	return &NullableTxCreateContract{value: val, isSet: true}
}

func (v NullableTxCreateContract) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTxCreateContract) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
